package test;

import java.util.Date;

import com.sun.star.beans.PropertyValue;
import com.sun.star.comp.helper.Bootstrap;
import com.sun.star.frame.XComponentLoader;
import com.sun.star.lang.XComponent;
import com.sun.star.lang.XMultiComponentFactory;
import com.sun.star.sheet.XSpreadsheet;
import com.sun.star.sheet.XSpreadsheetDocument;
import com.sun.star.table.XCell;
import com.sun.star.text.XText;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XComponentContext;

public class TestLibreOffice {

	public static void main(String[] args) {
		try {
			// Connect to Libreoffice and create a new Spreadsheet.
			XComponentContext xContext = Bootstrap.bootstrap();
			XMultiComponentFactory xMCF = xContext.getServiceManager();
			Object oDesktop = xMCF.createInstanceWithContext("com.sun.star.frame.Desktop", xContext);
			// query the desktop object for the XComponentLoader
			XComponentLoader xCLoader = (XComponentLoader) UnoRuntime.queryInterface(XComponentLoader.class, oDesktop);
			PropertyValue[] lProperties = new PropertyValue[2];
			XComponent xComp = xCLoader.loadComponentFromURL("private:factory/scalc", "_blank", 0, lProperties);
			XSpreadsheetDocument document = (XSpreadsheetDocument) UnoRuntime.queryInterface(XSpreadsheetDocument.class,
					xComp);
			// Deactivate Recalculation and Screenupdates to improve
			// performance.
			com.sun.star.sheet.XCalculatable xCalculateable = (com.sun.star.sheet.XCalculatable) UnoRuntime
					.queryInterface(com.sun.star.sheet.XCalculatable.class, document);
			xCalculateable.enableAutomaticCalculation(false);
			com.sun.star.frame.XModel xModel = (com.sun.star.frame.XModel) UnoRuntime
					.queryInterface(com.sun.star.frame.XModel.class, document);
			xModel.lockControllers();

			com.sun.star.document.XActionLockable xActionLockable = (com.sun.star.document.XActionLockable) UnoRuntime
					.queryInterface(com.sun.star.document.XActionLockable.class, document);

			xActionLockable.addActionLock();
			Object obj = document.getSheets().getByName(document.getSheets().getElementNames()[0]);
			XSpreadsheet sheet = UnoRuntime.queryInterface(XSpreadsheet.class, obj);
			long time = new Date().getTime();
			// Fille the Spreadsheet with some values in a loop.
			for (int row = 1; row < 1000; row++) {
				for (int col = 1; col < 20; col++) {
					XCell cell = sheet.getCellByPosition(col, row);
					XText xCellText = (XText) UnoRuntime.queryInterface(XText.class, cell);
					xCellText.insertString(xCellText.createTextCursor(), new Integer(row + col).toString(), false);
				}
			}
			// Report how long it took to fill the Spreadsheet.
			System.out.println("Time to fill Spreadsheet:" + (new Date().getTime() - time) + " milliseconds");
			// Reenable Autoupdates
			xActionLockable.removeActionLock();
			xModel.unlockControllers();
			xCalculateable.enableAutomaticCalculation(true);
			System.exit(0);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
